OpenJPH: ojph::local::tile Class Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::local::tile Class Reference

`#include <ojph_tile.h>`

## Public Member Functions
void | finalize_alloc (codestream *codestream, const rect &tile_rect, ui32 tile_idx, ui32 &offset, ui32 &num_tileparts)
bool | push (line_buf *line, ui32 comp_num)
void | prepare_for_flush ()
void | fill_tlm (param_tlm *tlm)
void | flush (outfile_base *file)
void | parse_tile_header (const param_sot &sot, infile_base *file, const ui64 &tile_start_location)
bool | pull (line_buf *, ui32 comp_num)
rect | get_tile_rect ()

## Static Public Member Functions
static void | pre_alloc (codestream *codestream, const rect &tile_rect, const rect &recon_tile_rect, ui32 &num_tileparts)

## Private Attributes
rect | tile_rect
ui32 | num_comps
tile_comp * | comps
ui32 | num_lines
line_buf * | lines
bool | employ_color_transform
bool | resilient
bool * | reversible
rect * | comp_rects
rect * | recon_comp_rects
ui32 * | line_offsets
ui32 | skipped_res_for_read
ui32 * | num_bits
bool * | is_signed
ui32 * | cur_line
ui8 * | nlt_type3
int | prog_order
param_sot | sot
int | next_tile_part
int | profile
ui32 | tilepart_div
bool | need_tlm
ui32 | num_bytes

## Detailed Description

Definition at line 60 of file ojph_tile.h.

## Member Function Documentation

## ◆ fill_tlm()

void ojph::local::tile::fill_tlm | ( | param_tlm * | tlm | ) |

Definition at line 529 of file ojph_tile.cpp.

References comps, num_comps, ojph_max, ojph::OJPH_PO_CPRL, ojph::OJPH_PO_LRCP, ojph::OJPH_PO_PCRL, ojph::OJPH_PO_RLCP, ojph::OJPH_TILEPART_COMPONENTS, ojph::OJPH_TILEPART_NO_DIVISIONS, ojph::OJPH_TILEPART_RESOLUTIONS, prog_order, ojph::local::param_tlm::set_next_pair(), sot, and tilepart_div.

## ◆ finalize_alloc()

void ojph::local::tile::finalize_alloc | ( | codestream * | codestream,
|  | const rect & | tile_rect,
|  | ui32 | tile_idx,
|  | ui32 & | offset,
|  | ui32 & | num_tileparts )

Definition at line 190 of file ojph_tile.cpp.

References ojph::local::codestream::access_cod(), comp_rects, comps, cur_line, employ_color_transform, ojph::local::codestream::get_allocator(), ojph::local::param_siz::get_bit_depth(), ojph::local::codestream::get_coc(), ojph::local::codestream::get_cod(), ojph::local::param_siz::get_downsampling(), ojph::local::codestream::get_nlt(), ojph::local::param_nlt::get_nonlinear_transform(), ojph::local::param_siz::get_num_components(), ojph::local::param_cod::get_num_decompositions(), ojph::local::codestream::get_profile(), ojph::param_cod::get_progression_order(), ojph::local::param_siz::get_recon_downsampling(), ojph::local::codestream::get_siz(), ojph::local::codestream::get_skipped_res_for_read(), ojph::local::codestream::get_tilepart_div(), ojph::local::param_cod::is_employing_color_transform(), ojph::local::codestream::is_resilient(), ojph::local::param_cod::is_reversible(), ojph::local::param_siz::is_signed(), is_signed, ojph::local::codestream::is_tlm_needed(), line_offsets, lines, need_tlm, next_tile_part, nlt_type3, num_bits, num_bytes, num_comps, num_lines, ojph_div_ceil, OJPH_ERROR, ojph_max, ojph::param_nlt::OJPH_NLT_NO_NLT, ojph::OJPH_TILEPART_COMPONENTS, ojph::OJPH_TILEPART_MASK, ojph::OJPH_TILEPART_NO_DIVISIONS, ojph::OJPH_TILEPART_RESOLUTIONS, ojph::mem_fixed_allocator::post_alloc_data(), ojph::mem_fixed_allocator::post_alloc_obj(), profile, prog_order, recon_comp_rects, resilient, reversible, skipped_res_for_read, sot, tile_rect, tilepart_div, ojph::point::x, and ojph::point::y.

## ◆ flush()

void ojph::local::tile::flush | ( | outfile_base * | file | ) |

Definition at line 583 of file ojph_tile.cpp.

References comps, num_comps, OJPH_ERROR, ojph_max, ojph::OJPH_PO_CPRL, ojph::OJPH_PO_LRCP, ojph::OJPH_PO_PCRL, ojph::OJPH_PO_RLCP, ojph::OJPH_PO_RPCL, ojph::OJPH_TILEPART_COMPONENTS, ojph::OJPH_TILEPART_NO_DIVISIONS, ojph::OJPH_TILEPART_RESOLUTIONS, prog_order, ojph::local::SOD, sot, ojph::swap_bytes_if_le(), tilepart_div, ojph::outfile_base::write(), ojph::point::x, and ojph::point::y.

## ◆ get_tile_rect()

rect ojph::local::tile::get_tile_rect | ( |  | ) |
| inline

Definition at line 75 of file ojph_tile.h.

References tile_rect.

Referenced by ojph::local::resolution::finalize_alloc().

## ◆ parse_tile_header()

void ojph::local::tile::parse_tile_header | ( | const param_sot & | sot,
|  | infile_base * | file,
|  | const ui64 & | tile_start_location )

Definition at line 776 of file ojph_tile.cpp.

References comps, ojph::error, next_tile_part, num_comps, OJPH_ERROR, OJPH_INFO, ojph_max, ojph::OJPH_PO_CPRL, ojph::OJPH_PO_LRCP, ojph::OJPH_PO_PCRL, ojph::OJPH_PO_RLCP, ojph::OJPH_PO_RPCL, ojph::infile_base::OJPH_SEEK_SET, prog_order, resilient, skipped_res_for_read, sot, ojph::infile_base::tell(), ojph::point::x, and ojph::point::y.

## ◆ pre_alloc()

void ojph::local::tile::pre_alloc | ( | codestream * | codestream,
|  | const rect & | tile_rect,
|  | const rect & | recon_tile_rect,
|  | ui32 & | num_tileparts )
| static

Definition at line 56 of file ojph_tile.cpp.

References ojph::local::codestream::get_allocator(), ojph::local::codestream::get_coc(), ojph::local::codestream::get_cod(), ojph::local::param_siz::get_downsampling(), ojph::local::param_siz::get_num_components(), ojph::local::param_cod::get_num_decompositions(), ojph::local::codestream::get_siz(), ojph::local::codestream::get_tilepart_div(), ojph::size::h, ojph::local::param_cod::is_employing_color_transform(), ojph::local::param_cod::is_reversible(), num_comps, ojph_div_ceil, OJPH_ERROR, ojph_max, ojph::OJPH_TILEPART_COMPONENTS, ojph::OJPH_TILEPART_MASK, ojph::OJPH_TILEPART_NO_DIVISIONS, ojph::OJPH_TILEPART_RESOLUTIONS, ojph::rect::org, ojph::local::tile_comp::pre_alloc(), ojph::mem_fixed_allocator::pre_alloc_data(), ojph::mem_fixed_allocator::pre_alloc_obj(), reversible, ojph::rect::siz, tile_rect, tilepart_div, ojph::size::w, ojph::point::x, and ojph::point::y.

Referenced by ojph::local::codestream::pre_alloc().

## ◆ prepare_for_flush()

void ojph::local::tile::prepare_for_flush | ( |  | ) |

Definition at line 520 of file ojph_tile.cpp.

References comps, num_bytes, and num_comps.

## ◆ pull()

bool ojph::local::tile::pull | ( | line_buf * | tgt_line,
|  | ui32 | comp_num )

Definition at line 424 of file ojph_tile.cpp.

References comps, cur_line, employ_color_transform, ojph::local::ict_backward, ojph::local::irv_convert_to_integer, ojph::local::irv_convert_to_integer_nlt_type3, is_signed, line_offsets, lines, nlt_type3, num_bits, num_comps, ojph::param_nlt::OJPH_NLT_BINARY_COMPLEMENT_NLT, ojph::local::rct_backward, recon_comp_rects, ojph::local::rev_convert, ojph::local::rev_convert_nlt_type3, and reversible.

## ◆ push()

bool ojph::local::tile::push | ( | line_buf * | line,
|  | ui32 | comp_num )

Definition at line 331 of file ojph_tile.cpp.

References comp_rects, comps, cur_line, employ_color_transform, ojph::local::ict_forward, ojph::local::irv_convert_to_float, ojph::local::irv_convert_to_float_nlt_type3, is_signed, line_offsets, lines, nlt_type3, num_bits, num_comps, ojph::param_nlt::OJPH_NLT_BINARY_COMPLEMENT_NLT, ojph::local::rct_forward, ojph::local::rev_convert, ojph::local::rev_convert_nlt_type3, and reversible.

## Member Data Documentation

## ◆ comp_rects

rect* ojph::local::tile::comp_rects
| private

Definition at line 86 of file ojph_tile.h.

Referenced by finalize_alloc(), and push().

## ◆ comps

tile_comp* ojph::local::tile::comps
| private

Definition at line 81 of file ojph_tile.h.

Referenced by fill_tlm(), finalize_alloc(), flush(), parse_tile_header(), prepare_for_flush(), pull(), and push().

## ◆ cur_line

ui32* ojph::local::tile::cur_line
| private

Definition at line 92 of file ojph_tile.h.

Referenced by finalize_alloc(), pull(), and push().

## ◆ employ_color_transform

bool ojph::local::tile::employ_color_transform
| private

Definition at line 84 of file ojph_tile.h.

Referenced by finalize_alloc(), pull(), and push().

## ◆ is_signed

bool* ojph::local::tile::is_signed
| private

Definition at line 91 of file ojph_tile.h.

Referenced by finalize_alloc(), pull(), and push().

## ◆ line_offsets

ui32* ojph::local::tile::line_offsets
| private

Definition at line 87 of file ojph_tile.h.

Referenced by finalize_alloc(), pull(), and push().

## ◆ lines

line_buf* ojph::local::tile::lines
| private

Definition at line 83 of file ojph_tile.h.

Referenced by finalize_alloc(), pull(), and push().

## ◆ need_tlm

bool ojph::local::tile::need_tlm
| private

Definition at line 103 of file ojph_tile.h.

Referenced by finalize_alloc().

## ◆ next_tile_part

int ojph::local::tile::next_tile_part
| private

Definition at line 98 of file ojph_tile.h.

Referenced by finalize_alloc(), and parse_tile_header().

## ◆ nlt_type3

ui8* ojph::local::tile::nlt_type3
| private

Definition at line 93 of file ojph_tile.h.

Referenced by finalize_alloc(), pull(), and push().

## ◆ num_bits

ui32* ojph::local::tile::num_bits
| private

Definition at line 90 of file ojph_tile.h.

Referenced by finalize_alloc(), pull(), and push().

## ◆ num_bytes

ui32 ojph::local::tile::num_bytes
| private

Definition at line 105 of file ojph_tile.h.

Referenced by finalize_alloc(), and prepare_for_flush().

## ◆ num_comps

ui32 ojph::local::tile::num_comps
| private

Definition at line 80 of file ojph_tile.h.

Referenced by fill_tlm(), finalize_alloc(), flush(), parse_tile_header(), pre_alloc(), prepare_for_flush(), pull(), and push().

## ◆ num_lines

ui32 ojph::local::tile::num_lines
| private

Definition at line 82 of file ojph_tile.h.

Referenced by finalize_alloc().

## ◆ profile

int ojph::local::tile::profile
| private

Definition at line 101 of file ojph_tile.h.

Referenced by finalize_alloc().

## ◆ prog_order

int ojph::local::tile::prog_order
| private

Definition at line 94 of file ojph_tile.h.

Referenced by fill_tlm(), finalize_alloc(), flush(), and parse_tile_header().

## ◆ recon_comp_rects

rect * ojph::local::tile::recon_comp_rects
| private

Definition at line 86 of file ojph_tile.h.

Referenced by finalize_alloc(), and pull().

## ◆ resilient

bool ojph::local::tile::resilient
| private

Definition at line 84 of file ojph_tile.h.

Referenced by finalize_alloc(), and parse_tile_header().

## ◆ reversible

bool* ojph::local::tile::reversible
| private

Definition at line 85 of file ojph_tile.h.

Referenced by finalize_alloc(), pre_alloc(), pull(), and push().

## ◆ skipped_res_for_read

ui32 ojph::local::tile::skipped_res_for_read
| private

Definition at line 88 of file ojph_tile.h.

Referenced by finalize_alloc(), and parse_tile_header().

## ◆ sot

param_sot ojph::local::tile::sot
| private

Definition at line 97 of file ojph_tile.h.

Referenced by fill_tlm(), finalize_alloc(), flush(), and parse_tile_header().

## ◆ tile_rect

rect ojph::local::tile::tile_rect
| private

Definition at line 79 of file ojph_tile.h.

Referenced by finalize_alloc(), get_tile_rect(), and pre_alloc().

## ◆ tilepart_div

ui32 ojph::local::tile::tilepart_div
| private

Definition at line 102 of file ojph_tile.h.

Referenced by fill_tlm(), finalize_alloc(), flush(), and pre_alloc().

The documentation for this class was generated from the following files:

- /build/openjph/src/OpenJPH/src/core/codestream/ojph_tile.h
- /build/openjph/src/OpenJPH/src/core/codestream/ojph_tile.cpp